Package javax.help.event

# Class EventListenerList

java.lang.Object
javax.help.event.EventListenerList

All Implemented Interfaces:
  `Serializable`

public class EventListenerList extends Object implements Serializable
A class that holds a list of EventListeners. A single instance can be used to hold all listeners (of all types) for the instance using the list. It is the responsiblity of the class using the EventListenerList to provide a type-safe API (preferably conforming to the JavaBeans specification) and methods that dispatch event notification methods to appropriate Event Listeners on the list. The main benefits this class provides are that it is relatively cheap if there are no listeners, provides serialization for eventlistener lists in a single place, and provides a degree of MT safety (when used correctly). Usage example: If one is defining a class that sends out FooEvents, and wants to allow users of the class to register FooListeners and receive notification when FooEvents occur. The following should be added to the class definition:

       EventListenerList listenrList = new EventListnerList();
       FooEvent fooEvent = null;

       public void addFooListener(FooListener l) {
           listenerList.add(FooListener.class, l);
       }

       public void removeFooListener(FooListener l) {
           listenerList.remove(FooListener.class, l);
       }

        // Notify all listeners that have registered interest for
        // notification on this event type.  The event instance
        // is lazily created using the parameters passed into
        // the fire method.

        protected void firefooXXX() {
            // Guaranteed to return a non-null array
            Object[] listeners = listenerList.getListenerList();
            // Process the listeners last to first, notifying
            // those that are interested in this event
            for (int i = listeners.length-2; i>=0; i-=2) {
                if (listeners[i]==FooListener.class) {
                    // Lazily create the event:
                    if (fooEvent == null)
                        fooEvent = new FooEvent(this);
                    ((FooListener)listeners[i+1]).fooXXX(fooEvent);
                }
            }
        }

foo should be changed to the appropriate name, and Method to the appropriate method name (one firing method should exist for each notification method in the FooListener interface).

Warning: Serialized objects of this class are not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between Swing1.0 applications. It will not be possible to load serialized Swing1.0 objects with future releases of Swing. The JDK1.2 release of Swing will be the compatibility baseline for the serialized form of Swing objects.

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected Object[]`
`listenerList`

## Constructor Summary

Constructors
Constructor
Description
`EventListenerList()`

## Method Summary

Modifier and Type
Method
Description
`void`
`add(Class t, EventListener l)`
Adds the listener as a listener of the specified type.
`int`
`getListenerCount()`
Returns the total number of listeners for this listenerList.
`int`
`getListenerCount(Class t)`
Returns the total number of listeners of the supplied type for this listenerList.
`Object[]`
`getListenerList()`
This passes back the event listener list as an array of ListenerType - listener pairs.
`void`
`remove(Class t, EventListener l)`
Removes the listener as a listener of the specified type.
`String`
`toString()`
Returns a string representation of the EventListenerList.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### listenerList

protected transient Object[] listenerList

## Constructor Details

### EventListenerList

public EventListenerList()

## Method Details

### getListenerList

public Object[] getListenerList()
This passes back the event listener list as an array of ListenerType - listener pairs. Note that for performance reasons, this implementation passes back the actual data structure in which the listener data is stored internally! This method is guaranteed to pass back a non-null array, so that no null-checking is required in fire methods. A zero-length array of Object should be returned if there are currently no listeners. WARNING!!! Absolutely NO modification of the data contained in this array should be made -- if any such manipulation is necessary, it should be done on a copy of the array returned rather than the array itself.

### getListenerCount

public int getListenerCount()
Returns the total number of listeners for this listenerList.

### getListenerCount

public int getListenerCount(Class t)
Returns the total number of listeners of the supplied type for this listenerList.

### add

public void add(Class t, EventListener l)
Adds the listener as a listener of the specified type.

Parameters:
  `t` - The type of the listener to be added.
  `l` - The listener to be added.
Throws:
  `IllegalArgumentException` - if `l` or `t` is null or `t` is not an instance of `l`.

### remove

public void remove(Class t, EventListener l)
Removes the listener as a listener of the specified type. If the listener for a given class does not exist in the list, it is ignored.

Parameters:
  `t` - The type of the listener to be removed.
  `l` - The listener to be removed.
Throws:
  `IllegalArgumentException` - if `l` or `t` is null or `t` is not an instance of `l`.

### toString

public String toString()
Returns a string representation of the EventListenerList.

Overrides:
  `toString` in class `Object`